/**************************************************
*   Author: Morrison
*   Date:  10 Nov 202020
**************************************************/

import javafx.application.Application;
import javafx.application.Platform;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.input.KeyEvent;
import javafx.scene.input.KeyCode;
import javafx.scene.paint.Color;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.layout.BorderPane;

public class KeyDemo extends Application
{
    private Canvas canvas;
    private double xLoc;
    private double yLoc;
    private final double SIZE = 50;
    public KeyDemo()
    {
        canvas = new Canvas(800,600);
        canvas.setFocusTraversable(true);
        canvas.requestFocus();
        xLoc = SIZE/2;
        yLoc = SIZE/2;
    }

    
    @Override
    public void init()
    {
    }

    @Override
    public void start(Stage primary)
    {
        primary.setTitle("Red Square");
        BorderPane bp = new BorderPane();
        bp.setCenter(canvas);
        refresh();
        canvas.setOnKeyPressed( e ->
        {
            KeyCode  k = e.getCode();
            System.out.println(k);
            if(k == KeyCode.UP)
            {
                yLoc -= 5;
            }
            else if(k == KeyCode.DOWN)
            {
                yLoc += 5;
            }
            else if(k == KeyCode.LEFT)
            {
                xLoc -= 5;
            }
            else if(k == KeyCode.RIGHT)
            {
                xLoc += 5;
            }
            refresh();
        });
        Scene scene = new Scene(bp);
        primary.setScene(scene);
        primary.show();
    }
    private void refresh()
    {
        GraphicsContext pen = canvas.getGraphicsContext2D();
        pen.setFill(Color.WHITE);
        pen.fillRect(0, 0, canvas.getWidth(), canvas.getHeight());
        pen.setFill(Color.RED);
        pen.fillRect(xLoc - SIZE/2, yLoc - SIZE/2, SIZE, SIZE);
    }

    @Override
    public void stop()
    {
    }
}
